#include <iostream>
#include <vector>

using namespace std;

template<typename T>
class MyQueue
{
protected:
    vector<T> data;
public:
    void Add(T const &input);
    void Remove();
    void Print();
    bool IsEmpty();
};

template<typename T>
void MyQueue<T>::Add(T const &input)
{
    data.push_back(input);
}
template<typename T>
void MyQueue<T>::Remove()
{
    data.erase(data.begin());
}

template<typename T>
void MyQueue<T>::Print()
{
    auto PrintIt = data.begin();
    while (PrintIt != data.end())
    {
        cout << *PrintIt << endl;
        PrintIt++;
    }
}

template<typename T>
bool MyQueue<T>::IsEmpty()
{
    return data.begin() == data.end();
}

int main()
{
    MyQueue<string> StringQueue;
    cout << StringQueue.IsEmpty() << endl;
    StringQueue.Add("Hallo");
    StringQueue.Add("Tschss");
    cout << "Strings ausgeben: " << endl;
    StringQueue.Print();
    cout << StringQueue.IsEmpty() << endl;
    StringQueue.Remove();
    cout << "Strings ausgeben: " << endl;
    StringQueue.Print();
    StringQueue.Remove();
    cout << StringQueue.IsEmpty() << endl;
    MyQueue<int> IntQueue;
    IntQueue.Add(1);
    IntQueue.Add(2);
    cout << "Ints ausgeben: " << endl;
    IntQueue.Print();
    return 0;
}

