#include <iostream>
#include "boost/numeric/conversion/converter.hpp"

using namespace std;
using namespace boost;
using namespace boost::numeric;

int main()
{
    // Converter erstellen.
    typedef converter<int, double> Double2Int;

    // Variablen fr das Beispiel anlegen.
    double MyDouble = 2.1;
    int MyInt = Double2Int::convert(MyDouble);

    // Ergebnisse ausgeben.
    cout << "Der double-Wert ist: " << MyDouble << endl;
    cout << "Der int-Wert ist: " << MyInt << endl;

    // Wie ist es bei einem greren Wert?
    MyDouble = 3.8;
    MyInt = Double2Int::convert(MyDouble);
    cout << "Der double-Wert ist: " << MyDouble << endl;
    cout << "Der int-Wert ist: " << MyInt << endl;

    // Wir wollen nicht abschneiden, also runden wir.
    typedef conversion_traits<int, double> Traits;
    typedef converter<int, double, Traits, def_overflow_handler,
                      RoundEven<double> > Double2Rounded;
    MyInt = Double2Rounded::convert(MyDouble);
    cout << "Der int-Wert ist: " << MyInt << endl;

    return 0;
}
